/* tc-vax.h -- Header file for tc-vax.c.
   Copyright (C) 1987, 91, 92, 93, 95, 96, 1997 Free Software Foundation, Inc.

   This file is part of GAS, the GNU Assembler.

   GAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GAS; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA. */

/* 25 Jan 1999. atp  VAX BFD_ASSEMBLER backend alterations. ELF target. */



#define TC_VAX 1

#define TARGET_ARCH             bfd_arch_vax

#define TARGET_BYTES_BIG_ENDIAN 0

#ifdef OBJ_AOUT
#ifdef TE_NetBSD
#define TARGET_FORMAT           "a.out-vax-netbsd"
#endif
#ifdef TE_386BSD
#define TARGET_FORMAT           "a.out-vax-bsd"
#endif
#ifdef TE_LINUX
#define TARGET_FORMAT           "a.out-vax-linux"
#endif
#endif

#ifdef OBJ_ELF
#define TARGET_FORMAT           "elf32-vax"
#endif

#define NOP_OPCODE 0x01

#ifdef BFD_ASSEMBLER
/* place elf & linux specfic here */
/* for elf relocs we want to defrob the stuff happening in fixup_segment */
#define MD_APPLY_FIX3

#define tc_fix_adjustable(X)  tc_vax_fix_adjustable(X)

/* This expression evaluates to false if the relocation is for a local object
   for which we still want to do the relocation at runtime.  True if we
   are willing to perform this relocation while building the .o file.
   This is only used for pcrel relocations, so GOTOFF does not need to be
   checked here.  I am not sure if some of the others are ever used with
   pcrel, but it is easier to be safe than sorry. */
/* arm and i386 versions differ? strange */

#define TC_RELOC_RTSYM_LOC_FIXUP(FIX)  \
  ((FIX)->fx_r_type != BFD_RELOC_VAX_PLT32 \
   && (FIX)->fx_r_type != BFD_RELOC_VAX_GOT32 \
   && (FIX)->fx_r_type != BFD_RELOC_VAX_GOTPC)

#define NO_RELOC BFD_RELOC_NONE

/* The name of the global offset table generated by the compiler. Allow
   this to be overridden if need be. */
#ifndef GLOBAL_OFFSET_TABLE_NAME
#define GLOBAL_OFFSET_TABLE_NAME "_GLOBAL_OFFSET_TABLE_"
#endif
#else  /* !bfd_assembler */

/* aout version */
#define NO_RELOC 0

#endif  /* !BFD_ASSEMBLER */

#define tc_aout_pre_write_hook(x)	{;}	/* not used */
#define tc_crawl_symbol_chain(a)	{;}	/* not used */
#define tc_headers_hook(a)		{;}	/* not used */
#define md_operand(x)

long md_chars_to_number PARAMS ((unsigned char *, int));

extern const struct relax_type md_relax_table[];
#define TC_GENERIC_RELAX_TABLE md_relax_table

/*
 * Local Variables:
 * comment-column: 0
 * fill-column: 131
 * End:
 */

/* end of tc-vax.h */
